SystemOrganization addCategory: #'A4BP-Tests-BPMN20-core'!
SystemOrganization addCategory: 'A4BP-Tests-BPMN20-core-model'!
SystemOrganization addCategory: 'A4BP-Tests-BPMN20-core-parser'!

TestCase subclass: #BPMN20ObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPMN20-core-model'!

BPMN20ObjectTest subclass: #BPMN20BaseElementImplTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPMN20-core-model'!

!BPMN20BaseElementImplTest methodsFor: 'tests-builder' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 16:24'!
testBuildInternalRelations! !

!BPMN20BaseElementImplTest methodsFor: 'builder-test' stamp: 'AlvaroJosePeraltaOcampo 3/14/2015 01:45'!
testDiagramsNode
	|parser v diagram plane shape|
	parser := BPMN20Parser new.
	parser parseString: BPMN20SampleVerySimpleProcess bpmn01.
	v:= parser lstElements first.
	v buildInternalRelations.
	
	"Start the test process"
	diagram := v diagrams.
	self assert: diagram notNil.
	self assert: diagram size >= 1.
	diagram := v diagrams values first.
	
	plane := diagram plane.
	self assert: plane notNil.
	
	shape := plane shapes values first.
	self assert: shape notNil.
	
	self assert: shape bounds x notNil.
	
! !

!BPMN20BaseElementImplTest methodsFor: 'builder-test' stamp: 'AlvaroJosePeraltaOcampo 3/9/2015 12:49'!
testbuildInternalRelations
	|toTest v e1 e2 e3|
	toTest := BPMN20Parser new.
	toTest parseString: BPMN20SampleVerySimpleProcess bpmn01.
	v:= toTest lstElements first.
	"Start the test process"
	v buildInternalRelations.

	e2 := v findElementById: 'SequenceFlow_1'.
	e3 := v findElementById: 'SequenceFlow_2'.
	
	e1 := v findElementById: 'StartEvent_1'.	
	self assert: (e1 outgoings at: 'SequenceFlow_1' ) = e2.	
		
	e1 := v findElementById: 'T1'.
	self assert: (e1 incomings at: 'SequenceFlow_1' ) = e2. 
	self assert: (e1 outgoings at: 'SequenceFlow_2' ) = e3.
	
	
	
	self assert: v numberOfInternalRelations = 0.! !

TestCase subclass: #BPMN20ParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-BPMN20-core-parser'!

!BPMN20ParserTest methodsFor: 'testDiagramsNode' stamp: 'AlvaroJosePeraltaOcampo 3/14/2015 22:08'!
testDiagramsNode
	|parser v diagram plane shape |
	parser := BPMN20Parser new.
	parser parseString: BPMN20SampleVerySimpleProcess bpmn01.
	v:= parser lstElements first.
	v buildInternalRelations.
	
	"Start the test process"
	diagram := v diagrams.
	self assert: diagram notNil.
	self assert: diagram size >= 1.
	diagram := v diagrams values first.
	
	plane := diagram plane.
	self assert: plane notNil.
	
	shape := plane shapes values first.
	self assert: shape notNil.
	
	self assert: shape bounds x notNil.
	self assert: shape bpmnElement notNil.! !

!BPMN20ParserTest methodsFor: 'testbasic' stamp: 'AlvaroJosePeraltaOcampo 12/1/2014 14:57'!
testId: v
	self assert: v id ~= nil.
	v childrens do:[ :e | self testId: e].! !

!BPMN20ParserTest methodsFor: 'testbasic' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 23:21'!
testparseBPMN20BaseElementImpl
	|toTest v|
	toTest := BPMN20Parser new.
	toTest parseString: BPMN20SampleLucasianSoftProcess bpmn2Concepcion.
	self assert: (toTest lstElements size > 0 ).
	v:= toTest lstElements first.
	self testId: v
! !

!BPMN20ParserTest methodsFor: 'testbasic' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 05:27'!
testparseString
	|toTest v|
	toTest := BPMN20Parser new.
	toTest parseString: BPMN20SampleLucasianSoftProcess bpmn2Concepcion.
	
	self assert: (toTest lstElements size > 0 ).
	v:= toTest lstElements first.
	self assert: v class = BPMN20DefinitionsImpl.
	'<bpmn:definitions fileRevision="20120601" version="12.1.3.0.0.00.00" xmlns:ns2="http://www.omg.org/spec/DD/20100524/DI" xmlns:ns4="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:ns3="http://www.omg.org/spec/DD/20100524/DC" xmlns:bpmnext="http://xmlns.oracle.com/bpm/OracleExtensions" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL">'.
	self assert: v fileRevision = '20120601'.
	self assert: v version = '12.1.3.0.0.00.00'.
	self assert: v rootElements size > 0.
	self assert: v process size > 0.
	v := v process at:'LucasianProDevConcepcion'.
	self assert: v class = BPMN20ProcessImpl.
	self assert: v aName = 'LucasianProDevConcepcion'.
	self assert: v laneSets size > 0.
	v := v laneSets first.
	self assert: v class = BPMN20LaneSetImpl.
	self assert: v lanes size > 0.
	v:= v lanes first.
	self assert: v class = BPMN20LaneImpl.
	self assert: v aName = 'GerenteDeProyecto'.! !
